close all
original=imread('penguin-orig.png');

downfactor=4;

original=double(original);
[nx ny]=size(original);

getmeasurements=ones(nx,ny);
getmeasurements(93:107,14:94)=0;
original=original(1:downfactor:end,1:downfactor:end);
getmeasurements=getmeasurements(1:downfactor:end,1:downfactor:end);


[nx ny]=size(original);
noise=20*randn(nx,ny);
corrupted=uint8(original+noise);
corrupted=double(corrupted);



corrupted=imread('penguin-bar.png');
corrupted=double(corrupted);
corrupted=corrupted(1:downfactor:end,1:downfactor:end)

beta2=10^2;
alpha2=3^2;

threshold=10^2/alpha2;

intensityarray=0:255;
newimage=corrupted;
solutionimageICM=corrupted;
solutionimageLBP=corrupted;
iterNo=200;

figure(34846)
subplot(1,4,1)
imshow(uint8(original))
subplot(1,4,2)
imshow(uint8(corrupted))
subplot(1,4,3)
imshow(uint8(corrupted))
title(['ICM Iter No: ', num2str(0)])
subplot(1,4,4)
imshow(uint8(corrupted))
title(['LBP Iter No: ', num2str(0)])
pause


messages=zeros(256,nx,ny);
tempmessages=zeros(256,nx,ny);

for i=1:nx,
    for j=1:ny,
        cost=exp(-0.5*(intensityarray-corrupted(i,j)).^2/(beta2));
        messages(:,i,j)=cost';
    end
end

TransferMatrix=zeros(256);
for i=1:256,
    TransferMatrix(i,:)=exp(-0.5*min((intensityarray-intensityarray(i)).^2/alpha2,threshold));
end


for iter=1:iterNo,
    iter
    newimage=solutionimageICM;
    %Main loop forward
    for i=1:nx,
        for j=1:ny,
            cost=zeros(1,256);
            if getmeasurements(i,j)
                cost=(intensityarray-corrupted(i,j)).^2/(beta2);
            end
            if i==1,
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
            elseif i==nx
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            end
            if j==1,
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);
            elseif j==ny
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);
            end
            if (i~=1)&&(i~=nx)&&(j~=1)&&(j~=ny)
                cost=cost+min((intensityarray-newimage(i+1,j+1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i+1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j+1)).^2/alpha2,threshold);
            end
            [minval minind]=min(cost);
            solutionimageICM(i,j)=intensityarray(minind);
        end
    end
    newimage=solutionimageICM;
    %An optional backward loop to speed up the convergence
    for i=nx:-1:1,
        for j=ny:-1:1,
            cost=zeros(1,256);
            if getmeasurements(i,j)
                cost=(intensityarray-corrupted(i,j)).^2/(beta2);
            end
            if i==1,
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
            elseif i==nx
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i+1,j)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j)).^2/alpha2,threshold);
            end
            if j==1,
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);
            elseif j==ny
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
            else
                cost=cost+min((intensityarray-newimage(i,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i,j+1)).^2/alpha2,threshold);
            end
            if (i~=1)&&(i~=nx)&&(j~=1)&&(j~=ny)
                cost=cost+min((intensityarray-newimage(i+1,j+1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i+1,j-1)).^2/alpha2,threshold);
                cost=cost+min((intensityarray-newimage(i-1,j+1)).^2/alpha2,threshold);
            end
            
            [minval minind]=min(cost);
            solutionimageICM(i,j)=intensityarray(minind);
        end
    end
    
    
    
    %loopy belief propagation
    for i=1:(nx),
        for j=1:(ny),
            cost=zeros(1,256);
            if getmeasurements(i,j)
                tempmessages(:,i,j)=exp(-0.5*(intensityarray-corrupted(i,j)).^2/(beta2))';
            else
                tempmessages(:,i,j)=ones(256,1);
            end
            if ((i<nx) && (j>1))
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i+1,j-1));
            end
            if ((i<nx) && (j<ny))
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i+1,j+1));
            end
            if (j>1)
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i,j-1));
            end
            if (j<ny)
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i,j+1));
            end
            if (i>1)
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i-1,j));
            end
            if (i<nx)
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i+1,j));
            end
            if ((i>1) && (j>1))
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i-1,j-1));
            end
            if ((i>1) && (j<ny))
                tempmessages(:,i,j)=tempmessages(:,i,j).*(TransferMatrix*messages(:,i-1,j+1));
            end
            tempmessages(:,i,j)=tempmessages(:,i,j)/sum(tempmessages(:,i,j));
            solutionimageLBP(i,j)=intensityarray*tempmessages(:,i,j);
        end
    end
    messages=tempmessages;
    
    
    
    
    %     totalenergy=sum(sum((solutionimage-corrupted).^2/beta2));
    %     for i=1:nx
    %         if i==1,
    %             totalenergy=totalenergy+sum(min((solutionimage(i+1,:)-solutionimage(i,:)).^2/alpha2,threshold));
    %         elseif i==nx
    %             totalenergy=totalenergy+sum(min((solutionimage(i,:)-solutionimage(i-1,:)).^2/alpha2,threshold));
    %         else
    %             totalenergy=totalenergy+sum(min((solutionimage(i+1,:)-solutionimage(i,:)).^2/alpha2,threshold));
    %             totalenergy=totalenergy+sum(min((solutionimage(i,:)-solutionimage(i-1,:)).^2/alpha2,threshold));
    %         end
    %     end
    %     totalenergy
    %
    
    subplot(1,4,3)
    imshow(uint8(solutionimageICM))
    title(['ICM Iter No: ', num2str(iter)])
    subplot(1,4,4)
    imshow(uint8(solutionimageLBP))
    title(['LBP Iter No: ', num2str(iter)])
    pause(0.05)
end



